//==========================================================================
// ᠭ  䨣樮 䠩
// 05-02-1999
//==========================================================================

#include <stdio.h>
#include <string.h>

#include "inifile.h"

/*
class TINIFile {

                TString sb;
                TStringList ls;

                int flag;
                unsigned long numline;

                void (*CheckLine)(TStringList *lstr,
                                  unsigned long numline);

                void Filter(int symbol);

        public:

                TINIFile(void);

                int LoadFile(char *ctlfile,
                             void (*CheckLine)(TStringList *lstr,
                                               unsigned long numline));

};
*/

#define NONE_SEARCH       0
#define REMING_SEARCH     1
#define SEARCH_0x22       2
#define SEARCH_0x27       3
#define SEARCH_END_LINE   4
#define SEARCH_END_REM    5
#define SEARCH_CLOSE_REM  6

TINIFile::TINIFile(void) {

        flag = NONE_SEARCH;
        numline = 1;
        ls.checkdupe = -1;
        CheckLine = NULL;

}

void TINIFile::Filter(int symbol) {

        // ᫨ 㦥 襭 䠩
        if(symbol == -1) {

                switch(flag) {

                        case SEARCH_0x22:
                        case SEARCH_0x27:
                             ls.Add(sb.Get());
                             break;

                        default:
                             ls.Add(strupr(sb.Get()));

                }

                sb.Clear();

                if(ls.Count()) {

                        if(CheckLine != NULL)
                        CheckLine(&ls, numline);

                        ls.Clear();

                }

                return;

        }

        switch(flag) {

                case NONE_SEARCH:
                     switch(symbol) {

                        case ' ':
                             ls.Add(strupr(sb.Get()));
                             sb.Clear();
                             break;

                        case ';':
                             ls.Add(strupr(sb.Get()));
                             if(ls.Count()) {

                                if(CheckLine != NULL)
                                CheckLine(&ls, numline);

                                ls.Clear();

                             }

                             sb.Clear();
                             flag = SEARCH_END_LINE;
                             break;

                        case '/':
                             flag = REMING_SEARCH;
                             break;

                        case 0x22:
                             flag = SEARCH_0x22;
                             ls.Add(strupr(sb.Get()));
                             sb.Clear();
                             sb.Add(symbol);
                             break;

                        case 0x27:
                             flag = SEARCH_0x27;
                             ls.Add(strupr(sb.Get()));
                             sb.Clear();
                             sb.Add(symbol);
                             break;

                        case '\n':
                             ls.Add(strupr(sb.Get()));
                             if(ls.Count()) {

                                if(CheckLine != NULL)
                                CheckLine(&ls, numline);

                                ls.Clear();

                             }
                             sb.Clear();
                             break;

                        default:
                             sb.Add(symbol);

                     }
                     break;

                case REMING_SEARCH:
                     switch(symbol) {

                        case '/':
                             ls.Add(strupr(sb.Get()));
                             if(ls.Count()) {

                                if(CheckLine != NULL)
                                CheckLine(&ls, numline);

                                ls.Clear();

                             }
                             sb.Clear();
                             flag = SEARCH_END_LINE;
                             break;

                        case '*':
                             ls.Add(strupr(sb.Get()));
                             sb.Clear();
                             flag = SEARCH_END_REM;
                             break;

                        default:
                             sb.Add('/');
                             sb.Add(symbol);
                             flag = NONE_SEARCH;

                     }
                     break;

                case SEARCH_0x22:
                     sb.Add(symbol);
                     if((symbol == 0x22) || (symbol == '\n')) {

                        ls.Add(sb.Get());
                        sb.Clear();
                        flag = NONE_SEARCH;

                     }
                     break;

                case SEARCH_0x27:
                     sb.Add(symbol);
                     if((symbol == 0x27) || (symbol == '\n')) {

                        ls.Add(sb.Get());
                        sb.Clear();
                        flag = NONE_SEARCH;

                     }
                     break;

                case SEARCH_END_LINE:
                     if(symbol == '\n') flag = NONE_SEARCH;
                     break;

                case SEARCH_END_REM:
                     if(symbol == '*') flag = SEARCH_CLOSE_REM;
                     break;

                case SEARCH_CLOSE_REM:
                     switch(symbol) {

                        case '*':
                             break;

                        case '/':
                             flag = NONE_SEARCH;
                             break;

                        default:
                             flag = SEARCH_END_REM;

                     }
                     break;

        }

        if(symbol == '\n') numline++;

}

int TINIFile::LoadFile(char *ctlfile,
                       void (*CheckLine)(TStringList *lstr,
                                         unsigned long numline)) {

        int symbol;

        FILE *ctl;

        TINIFile::CheckLine = CheckLine;

        if((ctl = fopen(ctlfile, "r")) != NULL) {

                while((symbol = getc(ctl)) != EOF)
                Filter(symbol);

                Filter(-1);

                fclose(ctl);

                return (0);

        }

        return (-1);

}

#undef NONE_SEARCH
#undef REMING_SEARCH
#undef SEARCH_0x22
#undef SEARCH_0x27
#undef SEARCH_END_LINE
#undef SEARCH_END_REM
#undef SEARCH_CLOSE_REM

//==========================================================================
